#include "conversor.h"
#include "ui_conversor.h"
#include <QFileDialog>
#include <QFile>
#include <QFileInfo>
#include <QFileInfoList>
#include <QMessageBox>



#include "definiciones.h"


bool activefiltro = true; // Activar filtro de video.

conversor::conversor(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::conversor)
{


    ui->setupUi(this);
    ui->cmbResolucion->setCurrentIndex(8);






}

conversor::~conversor()
{
    QProcess::execute(MPDOWN);


    delete ui;

}

void conversor::on_cmdSalir_clicked()
{
    QProcess::execute(MPDOWN);
    exit(0);
}

void conversor::on_cmbformato_activated(int index)
{
    // Si esta marcada la opcion mpg calidad desactiva los demas
    // controles de resolucion y pasos, pues ya estan predefinidos.

    // Si se marca mp4 y aac tambien se desactivan
    // pasos y resolucion porque ya estan predefinidos.

    if (!(index == 0)) {

        this->ui->cmbResolucion->setDisabled(false);
        this->ui->cmbPasos->setDisabled(false);

    } else {
         this->ui->cmbResolucion->setDisabled(true);
         this->ui->cmbPasos->setDisabled(true);
    }


    if (index == 1) {

        this->ui->cmbResolucion->setDisabled(true);
        this->ui->cmbPasos->setDisabled(true);
    }
}

void conversor::on_cmdFentrada_clicked()
{
    QString fileName = "";
    QFileDialog dlg;


    fileName = dlg.getExistingDirectory(0, "Carpeta de entrada");

    this->ui->txtEntrada->setText(fileName);

    this->ui->cmdConvertir->setDisabled(false);


}

void conversor::on_cmdFsalida_clicked()
{
    QString fileName = "";
    QFileDialog dlg;


    fileName = dlg.getExistingDirectory(0, "Carpeta de entrada");

    this->ui->txtSalida->setText(fileName);
}

void conversor::on_cmdConvertir_clicked()
{



    if (this->ui->txtEntrada->text() == "") {
        QMessageBox::warning(0,"Error", "No se ha marcado carpeta de entrada.");
        return;
    }

    if (this->ui->txtSalida->text() == "") {
        QMessageBox::warning(0,"Error", "No se ha marcado carpeta de salida.");
        return;
    }



    this->ui->txtEntrada->setDisabled(true);
    this->ui->txtSalida->setDisabled(true);
    this->ui->cmdFentrada->setDisabled(true);
    this->ui->cmdFsalida->setDisabled(true);

    // Inicio del proceso de conversion

    //Leer todos los archivos de la carpeta de entrada a una lista.

    QDir di;
    QStringList filtro;

    if (activefiltro) {

    filtro << "*.avi" << "*.mpg" << "*.mkv" << "*.3gp" << "*.mp4" << "*.flv"
           << "*.fla" << "*.mpeg" << "*.xvid" << "*.div*" << "*.dvd"
           << "*.AVI" << "*.MPG" << "*.MP4" << "*.wmv" << "*.ogv"
           << "*.webm" << "*.dv" << "*.raw";



    } else {

        filtro << "*.*";

    }

    di.setFilter(QDir::Files | QDir::NoDotAndDotDot | QDir::Readable);
    di.setNameFilters(filtro);
    di.setSorting(QDir::Name | QDir::Reversed);
    di.setCurrent(this->ui->txtEntrada->text());

    QFileInfoList list = di.entryInfoList();

    //Comienzo deconversion

    for (int i = 0; i < list.size(); i++) {

        QFileInfo info = list.at(i);
        this->ui->lstVideos->insertItem(0, info.fileName());



        if (this->ui->cmbformato->currentIndex() == 0) {

            //Conversion mpeg HD
           video2calidadmpeg(this->ui->txtEntrada->text(), this->ui->txtSalida->text(), info.fileName(), this->ui->txtEntrada->text().append("/").append(info.baseName()).append(".srt"), BINCONV);

        } else if (this->ui->cmbformato->currentIndex() == 1) {
            //Conversion mp4 y aac moviles.
            video2mp4aac(this->ui->txtEntrada->text(), this->ui->txtSalida->text(), info.fileName(), this->ui->txtEntrada->text().append("/").append(info.baseName()).append(".srt"), BINCONV);



        } else if (this->ui->cmbformato->currentIndex() == 2) {

            //Conversion xvid estandar
            video2xvid(this->ui->txtEntrada->text(), this->ui->txtSalida->text(), info.fileName(), this->ui->txtEntrada->text().append("/").append(info.baseName()).append(".srt"), BINCONV,this->ui->cmbResolucion->itemText(this->ui->cmbResolucion->currentIndex()) ,this->ui->cmbPasos->itemText(this->ui->cmbPasos->currentIndex()));
            this->ui->cmbResolucion->setDisabled(false);
            this->ui->cmbPasos->setDisabled(false);

        }


    }


    this->ui->txtEntrada->setDisabled(false);
    this->ui->txtSalida->setDisabled(false);
    this->ui->cmdFentrada->setDisabled(false);
    this->ui->cmdFsalida->setDisabled(false);
   //this->ui->cmdConvertir->setDisabled(true);

    this->ui->lstVideos->clear();

}

void conversor::on_chkFiltros_clicked()
{


    activefiltro = !(activefiltro);



}

void conversor::on_cmdCreditos_clicked()
{
    QMessageBox::about(0, "Créditos.", "Creado por Haylem Candelario Bauzá.\n2014. Cuba.\nGPLv2 Software Libre");
    QMessageBox::aboutQt(0, "Creado con QT");

}







